<?php

//TODO: build in support for more kinds of configs by regex
//TODO: build in support for multiple variables

class Core_Drivers_ArrayConfig extends Core_Driver 
    implements Core_DriverBindings
{

    protected $File = null;
    protected $Config = array();
    
    
    protected function construct()
    {
        $Dirs = $this->getEntireSource();
        $FileName = array_pop($Dirs);
        //load the file
        $this->File = $this->getHarddriver
            (
                "Core", 
                "File", 
                array
                (
                    "Path" => Core_LibsysPaths::getFile
                        (
                            $this->getPart(), 
                            $Dirs,
                            strtolower($FileName).".conf"
                        )
                )
            );
        if ( $this->File instanceof Core_Null )
        { 
            return;
        };
        //get the used variable
        $Matches = array();
        preg_match_all
            (
                '/\$([A-Za-zx_]+)/', 
                $this->File->getContent(),
                $Matches
            );
        if ( !isset($Matches[1][0]) )
        { 
            return;
        };
        $Var = $Matches[1][0];
        //check if there really is a var
        if ( empty($Var) )
        { 
            return;
        };
        //load the file
        ob_start();
        include ($this->File->getPath());
        ob_end_clean();
        //save the config
        $this->Config = $$Var;
        $this->succeed();
        
    }
    
    protected function displayVariableContent($Var)
    {
        $Display = "";
        switch ( gettype($Var) )
        {
            case "string":
                $Display .= "\"" . addslashes($Var) . "\"";
                break;
            case "integer":
            case "double":
                $Display .= $Var;
                break;
            case "array":
                $Display .= "array(";
                $FirstIteration = true;
                foreach ( $Var as $Key => $Value )
                {
                    if ( $FirstIteration == true ) 
                    {
                        $Display .= " ";
                    }
                    else
                    {
                        $Display .= ", ";
                    };
                    $Display .= $this->displayVariableContent($Key);
                    $Display .= " => ";
                    $Display .= $this->displayVariableContent($Value);
                    $FirstIteration = false;
                };
                $Display .= ")";
                break;
            default:
                $Display .= "null";
                //TODO: add support for objects? ...
        };
        return $Display;
    }
    
    protected function createFileContent($Receiver)
    {
        $FileContent = "";
        $FileContent .= "<?php \n";
        $FileContent .= 
            "/* file dynamically changed by driver ArrayConfig */\n";
        $FileContent .= "\n";
        $FileContent .= "\$Data = ";
        $FileContent .=
            $this->displayVariableContent($Receiver->getDeepTable());
        $FileContent .= ";\n";
        $FileContent .= "\n";
        $FileContent .= "?>";
        return $FileContent;
    }
    
    public function getObject()
    {
        return new Core_Table($this->Config);
    }
    
    public function getText()
    {
        return ""; //no good output possible
    }
    
    public function getList()
    {
        return array(); //no good output possible
    }
    
    public function getTable()
    {
        return array(); //no good output possible
    }
    
    public function getDeepList()
    {
        return array($this->Config);
    }


    public function getDeepTable()
    { 
        return $this->Config;
    }
    
    public function set($Receiver)
    {
        if ( count($Receiver->getDeepTable(), 1) < 1 )
        {
            $FileContent = "";
        }
        else
        {
            $FileContent = $this->createFileContent($Receiver);
        };
        $this->File->setContent($FileContent);
        return true;
    }
    
}



 ?>