<?php

class Core_Drivers_Directory extends Core_Driver 
    implements Core_DriverBindings
{

    protected $Path = "";
    protected $Dir = null;

    protected function construct()
    {
        //read in the directory
        switch ( strtolower($this->getParam("Location") ) )
        {
            case "extern":
                //TODO: Build in this feature!!!
                break;
            case "intern":
                //explicit access to default
                //no break
            default:
                switch ( strtolower($this->getParam("Type")) )
                {
                    case "cache":
                        $this->Path = Core_LibsysPaths::getCache
                            ($this->getSource());
                        break;
                    case "log":
                        $this->Path = Core_LibsysPaths::getLog
                            ($this->getSource());
                        break;
                    case "part":
                        $this->Path = Core_LibsysPaths::getPart
                            ($this->getPart());
                        break;
                    case "sub":
                        //explicit access to default
                        //no break
                    default:
                        $this->Path = Core_LibsysPaths::getDir
                            ($this->getPart(), $this->getSource());
                };
        };
        //create a harddriver
        $this->Dir = $this->getHarddriver
                ("Core", "Directory", array("Path" => $this->Path));
        //check if the harddriver has succeeded
        if ( $this->Dir->getSuccess() != true )
        {
            return;
        };
        $this->succeed();
    }
    
    public function getObject()
    {
        return new Core_Table($this->getDeepTable());
    }
    
    public function getText()
    {
        $Text = "";
        foreach ( $this->Dir->getEntries() as $Number => $Entry )
        {
            $Text .= $Entry . "\n"; 
        };
        return $Text;
    }
    
    public function getList()
    {
        return $this->Dir->getEntries();
    }
    
    public function getTable()
    {
        return $this->Dir->getEntries();
    }
    
    public function getDeepList()
    {
        return $this->readDirRecursive($this->Dir->getPath);
    }


    public function getDeepTable()
    {
        return $this->getDeepList();
    }
    
    public function set()
    {
        //not really possible....
    }
    
    
    protected function readDirRecursive($Dir)
    {
        //define an array for the recursive list
        $DirList = array();
        //set up the working directory
        $WorkingDir = $this->getHarddriver
                ("Core", "Directory", array("Path" => $Dir));
        //go through each entry 
        foreach ( $WorkingDir->getEntries as $Number => $Entry )
        {
            //create path for a subdir
            $Path = $WorkingDir->getPath . "/" . $Entry . "/";
            //initiate a new harddriver for this subdir
            $WorkingDir = $this->getHarddriver
                    ("Core", "Directory", array("Path" => $Path)); 
            //check if the harddriver had success
            if ( $WorkingDir->getSuccess == true )
            {
                //read in the subdir and add it to the array
                $DirList[] = $this->readDirRecursive($WorkingDir->getPath());
            }
            else
            {
                //add the file to the array
                $DirList[] = $Entry;
            };
        };
        //return the list
        return $DirList;
        
    }

}



 ?>