<?php

class Core_Drivers_Parts extends Core_Driver 
    implements Core_DriverBindings
{
    protected $Parts = array();

    protected function construct()
    {
        //load the configuration file
        $PartsConfig = $this->getDriver
            (
                "Core", 
                "ArrayConfig", 
                "Core",
                array("Config", "Parts")
            );
        //load the available dirs
        $PartsDirs = $this->getHarddriver("Core", "PartDirs");
        //go through the parts config and check if the part really exists
        foreach ( $PartsConfig->getDeepTable() as $Part => $Active )
        { 
            if 
            ( 
                ($Active == true) 
                && in_array($Part, $PartsDirs->getParts()) 
            )
            { 
                $this->Parts[] = $Part;
                $this->succeed();
            };
        };
    }
    
    public function getObject()
    {
        return new Core_Table($this->getDeepTable());
    }
    
    public function getText()
    {
        //no very good information possible
        $Text = "";
        foreach ( $this->Parts as $Number => $Part )
        {
            $Text .= $Part . " ";
        };
        return $Text;
    }
    
    public function getList()
    {
        return $this->Parts;
    }
    
    public function getTable()
    {
        return $this->Parts;
    }
    
    public function getDeepList()
    {
        return $this->getList();
    }


    public function getDeepTable()
    {
        return $this->getTable();
    }
    
    public function set($Receiver)
    {
        //you might edit the part configuration but you really SHOULDN'T!
    }
   

}

 ?>