<?php

class Core_Harddrivers_Directory extends Core_Harddriver
    implements Core_HarddriverBindings
{

    protected $Path = "";
    protected $Entries = array();
    
    protected function construct()
    {
        //get the location
        $this->Path = $this->getFirstParam(array("Path", "Location"));
        //check if directory exists
        if ( !is_dir($this->Path) )
        { 
            return false;
        };
        //read in the entries of the directory
        $DirResource = opendir($this->Path);
        while ( ($Entry = readdir($DirResource)) !== false ) 
        { 
            //strip out the unix links to the current and parent dir
            if ( ($Entry == ".") || ($Entry == "..") )
            {
                continue;
            };
            $this->Entries[] = $Entry;
        };
        closedir($DirResource);    
        $this->succeed();
    }
    
    public function getEntries()
    {
        return $this->Entries;
    }
    
    public function getPath()
    {
        return $this->Path;
    }
    
    public function setPath($NewPath)
    {
        rename($this->Path, $NewPath);
    }


}

 ?>