<?php

abstract class Core_Data
{

    private $data_Success_Success = false;
    private $data_AutoVars_Vars = array();
    
    private $data_ForcedUsingSuccess = null;
    private $data_ForcedUsingAutoVars = null;
    private $data_ForcedUsingGetVars = null;
    private $data_ForcedUsingGetVarsWithGet = null;
    private $data_ForcedUsingReport = null;
    
    protected $data_UsingSuccess = false;
    protected $data_UsingAutoVars = false;
    protected $data_UsingGetVars = false; 
    protected $data_UsingGetVarsWithGet = false;
    protected $data_UsingReport = false;
    
    
    private final function data_getFeatureVar($Feature, $Forced=false)
    {
        if ( $Forced == true )
        {
            return ("data_ForcedUsing" . $Feature);
        }
        else
        {
            return ("data_Using" . $Feature);
        };
    }
    
    protected final function data_use($Feature, $Value=true)
    {
        $UsingFeatureVarName = $this->data_getFeatureVar($Feature);
        $this->$UsingFeatureVarName = $Value;
        return $Value;
        //for those who want it tricky :
        //return $this->{$this->data_getFeatureVar($Feature)} = $Value;
    }
    
    protected final function data_useForced($Feature, $Value=true)
    {
        $ForcedUsingFeatureVarName = $this->data_getFeatureVar($Feature, true);
        //check if the value is already set
        if ( $this->$ForcedUsingFeatureVarName !== null )
        { 
            return null;
        };
        $this->$ForcedUsingFeatureVarName = $Value;
        return $Value;
        //for those who want it tricky :
        //return $this->{$this->data_getFeatureVar($Feature, true)} = $Value;
        // ...and some bit more i'll try to add
    }
    
    protected final function data_Success_succeed()
    {
        if ( !$this->data_isUsing("Success") ) { return null; };
        $this->data_Success_Success = true;
        return true;
    }
    
    
    protected function succeed()
    {
        //frontend for $this->data_Success_succeed()
        return $this->data_Success_succeed();
    }
    
    
    public final function data_isUsing($Feature)
    {
        $ForcedUsingFeatureVarName = $this->data_getFeatureVar($Feature, true);
        $UsingFeatureVarName = $this->data_getFeatureVar($Feature, false);
        if ( $this->$ForcedUsingFeatureVarName == true )
        {
            return true;
        };
        if ( $this->$UsingFeatureVarName == true )
        {
            return true;
        }
        else
        {
            return false;
        };
    }
    
    public final function data_Success_get()
    {
        if ( !$this->data_isUsing("Success") ) { return null; };
        return $this->data_Success_Success;
    }
    
    public final function data_AutoVars_get($Var)
    {
        if ( !$this->data_isUsing("AutoVars") ) { return null; };
        if ( isset($this->data_AutoVars_Vars[$Var]) )
        {
            return $this->data_AutoVars_Vars[$Var];
        };
        return null;
    }
    
    
    public final function data_AutoVars_set($Var, $Value)
    {
        if ( !$this->data_isUsing("AutoVars") ) { return null; };
        $this->data_AutoVars_Vars[$Var] = $Value;
        return $Value;
    }
    
    
    public final function data_GetVars_get($Var)
    {
        if ( !$this->data_isUsing("GetVars") ) { return null; };
        //check if it isn't a var from this class itself
        if ( preg_match('/^data_.*/', $Var) == true )
        {
            return null;
        };
        //check if it isn't meant not to be available
        if ( preg_match('/.*_\$/', $Var) == true )
        {
            break;
        };
        //check if we can access the requested var
        if ( in_array($Var, get_object_vars($this)) )
        {   
            return $this->$Var;
        };
        return null;
    }
    
    public final function data_GetVarsWithGet_get($Method)
    {
        if ( !$this->data_isUsing("GetVarsWithGet") ) { return null; };
        //use the GetVars feature
        $this->data_use("GetVars");
        //check if it has a properly form
        if ( preg_match('/get[A-Za-z][A-Za-zx_]*/', $Method) != true )
        {
            return null;
        };
        //get the var name
        $Var = preg_replace('/^get/', "", $Method);
        return $this->data_GetVars_get($Var); 
    }
    
    
    public final function data_Report_get()
    {
        if ( !$this->data_isUsing("Report") ) { return null; };
        $Report = array();
        //get all accessable vars
        $Vars = get_object_vars($this);
        //go through all vars and take over some to the report
        foreach ( $Vars as $Number => $Var )
        {
            //check if it isn't from Core_Data itself
            if ( preg_match('/^data_.*/', $Var) == true )
            {
                break;
            };
            //check if it isn't meant not to appear in the report
            if ( preg_match('/.*_\$/', $Var) == true )
            {
                break;
            };
            //take over 
            $Report[] = $Var;
        };
        //return the report
        return $Report;
    } 
    
    
    
    
    public function __get($Var)
    {
        if ( $this->data_isUsing("AutoVars") )
        {
            return $this->data_AutoVars_get($Var);
        };
        return null;
    }
    
    public function __set($Var, $Value)
    {
        if ( $this->data_isUsing("AutoVars") )
        {
            $this->data_AutoVars_set($Var, $Value);
        };
    }
   
    public function __call($Method, $Params)
    {
        if ( $this->data_isUsing("GetVars") )
        {
            return $this->data_GetVars_get($Method);
        };
        if ( $this->data_isUsing("GetVarsWithGet") )
        {
            return $this->data_GetVarsWithGet_get($Method);
        };
        return null;
    }
    
    
    public function getSuccess()
    {
        //frontend for $this->data_Success_get()
        return $this->data_Success_get();
    }
    
    public function getReport()
    {
        //frontend for $this->data_Success_get()
        return $this->data_Report_get();
    }
    
    public function isUsing($Feature)
    {
        //frontend for $this->data_isUsing()
        return $this->data_isUsing($Feature);
    }
   




}


 ?>