<?php

abstract class Core_Driver extends Core_GenericDriver
{

    private $Part = "";
    private $Source = "";

    public final function __construct($Part, $Source, $Params=array())
    {
        $this->Part = $Part;
        switch ( gettype($Source) )
        {
            case "array":
                $this->Source = $Source;
                break;
            default: 
                $this->Source = array($Source);
        };
        parent::__construct($Params);
    }
    
    public final function __destruct()
    {
        parent::__destruct();
    }

   
    public function getObject()
    {
        return new Core_Table($this->getDeepTable());
    }
    
    
    public function getText()
    {
        return "";
    }
    
    public function getList()
    {
        return array();
    }
    
    public function getTable()
    {
        return array();
    }
    
    public function getDeepList()
    {
        return array();
    }
    
    public function getDeepTable()
    {
        return array();
    }
    
    
    
    public final function getArray()
    {
        return $this->getList();
    }
    
    public final function getHash()
    {
        return $this->getTable();
    }
    
    public final function getDeepArray()
    {
        return $this->getDeepList();
    }
    
    public final function getDeepHash()
    {
        return $this->getDeepTable();
    }
    
    
    
    protected final function getPart()
    {
        return $this->Part;
    }
    
    protected final function getSource($What="0")
    {
        if ( isset($this->Source[$What]) )
        {
            return $this->Source[$What];
        };
        return null;  
    }
    
    protected final function getEntireSource()
    { 
        return $this->Source;
    }
    
    protected final function getFirstSource($What=array())
    {
        if ( gettype($What) == "array" )
        {
            foreach ( $What as $Number => $Source )
            {
                if ( isset($this->Source[$What]) )
                {
                    return $this->Source[$What];
                };
            };
        }
        else
        {
            return $this->getSource($What);
        };
        return null;
        
    }
   
    
    protected final function getDriver
        ($DriverPart, $DriverName, $Part, $Source, $Params=array())
    {
        $ClassName = parent::getGenericDriverClass
                (
                    $DriverPart, 
                    $DriverName, 
                    "Drivers", 
                    Core_LibsysClasses::getName("Core", "Driver"),
                    Core_LibsysClasses::getName("Core", "DriverBindings")
                );
        if ( !empty($ClassName) )
        {
            return new $ClassName ($Part, $Source, $Params);
        };
        return new Core_Null();
    }    
    
    protected final function getHarddriver
        ($DriverPart, $DriverName, $Params=array())
    {
        $ClassName = parent::getGenericDriverClass
                (
                    $DriverPart, 
                    $DriverName, 
                    "Harddrivers", 
                    Core_LibsysClasses::getName("Core", "Harddriver"),
                    Core_LibsysClasses::getName("Core", "HarddriverBindings")
                );
        if ( !empty($ClassName) )
        {
            return new $ClassName ($Params);
        };
        return new Core_Null();
    }
   
}


 ?>