<?php

abstract class Core_Extension
{

    private $Usage = false;
    private $Frozen = false;
    
    protected $Vars = array();

    public final function __construct()
    {
        //call specific constructor
        if ( method_exists($this, "construct") )
        {
            $this->construct();
        };
    }
    
    public final function __destruct()
    {
        //call specific constructor
        if ( method_exists($this, "destruct") )
        {
            $this->destruct();
        };
    }
    
    public final function use($Usage=true)
    {
        if ( $this->Frozen == false )
        {
            if ( $Usage == true )
            {
                $this->Usage = true;
            }
            else
            {
                $this->Usage = false;
            };
        };
    }
    
    public final function freeze()
    {
        $this->Frozen = true;
    }
    
    public final function isUsed()
    {
        return $this->Usage;
    }

    public final function updateVars($Vars)
    {
        if ( is_array($Vars) )
        {
            $this->Vars = $Vars;
        };
    }
    
    protected final function get($Var)
    {
        if ( isset($this->Vars[$Var]) )
        {
            return $this->Vars[$Var];
        };
        return null;
    }

}

 ?>