<?php

abstract class Core_GenericDriver extends Core_Data
{
    private $DriverParameters = array();

    public function __construct($Params=array())
    {
        //set the parameters for Core_Data
        $this->data_useForced("GetVars");
        $this->data_useForced("Success");
        $this->data_useForced("Report");
        //check the params
        if ( is_array($Params) )
        {
            $this->DriverParameters = $Params;
        }
        else
        {
            $this->DriverParameters = array(0 => $Params);
        };
        //call specific constructor
        if ( method_exists($this, "construct") )
        {
            $this->construct();
        };
    }
    
    public function __destruct()
    {
        //call specific constructor
        if ( method_exists($this, "destruct") )
        {
            $this->destruct();
        };
    }
    
    
    protected function getGenericDriverClass
            ($Part, $Name, $Type, $ExtendedClass, $ImplementedIface)
    {
        //generate the class name
        $ClassName = Core_LibsysClasses::getName($Part, $Type, $Name);
        //check if the class is properly
        if 
        (
            class_exists($ClassName)
            && Core_LibClass::extendsClass($ClassName, $ExtendedClass)
            && Core_LibClass::implementsIface($ClassName, $ImplementedIface)
        )
        {
            return $ClassName;
        };
        return false;
    }
    
    protected final function getParam($Name=0)
    {
        if ( isset($this->DriverParameters[$Name]) )
        {
            return $this->DriverParameters[$Name];
        };
        if ( isset($this->DriverParameters[strtolower($Name)]) )
        {
            return $this->DriverParameters[strtolower($Name)];
        };
        return null;
    }
    
    protected final function getFirstParam($Names)
    {
        foreach ( $Names as $Key => $Name )
        {
            if ( $this->getParam($Name) !== null )
            {
                return $this->getParam($Name);
            };
        };
        return null;
    }
    
    protected final function getParams()
    {
        return $this->DriverParameters;
    }
    
    
    
  
    
   
    
}


 ?>