<?php

//frontend for the systhemes
abstract class Core_LibsysPaths
{

    protected function buildArgs($Args)
    {
        $List = "";
        if ( !is_array($Args) )
        {
            $Args = array($Args);
        };
        $List .= "(";
        $i = 0;
        foreach ( $Args as $Number => $Arg )
        {
            if ( $i != 0 )
            {
                $List .= ", ";
            };
            $List .= ("\"" . $Arg . "\"");
            $i ++;        
        };
        $List .= ")";
        return $List;
    }
    
    protected function buildPath($Dirs)
    {
        $Path = "";
        if ( !is_array($Dirs) )
        {
            $Dirs = array($Dirs);
        };
        foreach ( $Dirs as $Number => $Dir )
        {
            if ( !is_string($Dir) )
            {
                continue;
            };
            $Path .= ($Dir . "/");
        };
        return $Path;
    }
    
    
    protected function completeMatchArgs($Params=array())
    {
        if ( !is_array($Params) )
        {
            $Params = array();
        };
        if ( !isset($Params["part"]) )
        {
            $Params["part"] = "[a-z]+";
        };
        if ( !isset($Params["type"]) )
        {
            $Params["type"] = "[a-z]+";
        };
        if ( !isset($Params["dir"]) )
        {
            $Params["dir"] = "[a-z0-9]+";
        };
        if ( !isset($Params["file"]) )
        {
            $Params["file"] = "[a-zA-Z0-9x_]+";
        };
        if ( !isset($Params["extension"]) )
        {
            $Params["extension"] = "[a-z]+";
        };
        return $Params;
    }
    
    

    public static function getRoot()
    {
        return SystemTheme_Paths::getRoot();
    } 
   
    
    
    
    public static function getParts()
    {
        return SystemTheme_Paths::getPartsDir();
    }
    
    public static function getPart($Part)
    {
        return SystemTheme_Paths::getPart($Part);
    }
    
    public static function getDir($Part, $Dir)
    {
        $Dir = self::buildPath($Dir);
        return SystemTheme_Paths::getSubdir($Part, $Dir);           
    }
    
    public static function getFile($Part, $Dir, $File)
    {
        $Dir = self::buildPath($Dir);
        return SystemTheme_Paths::getFile($Part, $Dir, $File);           
    }
    
    
    
    
    public static function getLogs()
    {
        return SystemTheme_Paths::getLogDir();
    }
    
    public static function getLog($Log)
    {
        $Log = self::buildPath($Log);
        return SystemTheme_Paths::getLogs($Log);
    }
    
    public static function getLogFile($Log, $File)
    {
        $Log = self::buildPath($Log);
        return SystemTheme_Paths::getLogFile($Log, $File);
    }
    
    
    
    
    public static function getCaches()
    {
        return SystemTheme_Paths::getCacheDir();
    }
    
    public static function getCache($Cache)
    {
        $Cache = self::buildPath($Cache);
        return SystemTheme_Paths::getCache($Cache);
    }
    
    public static function getCacheFile($Cache, $File)
    {
        $Cache = self::buildPath($Cache);
        return SystemTheme_Paths::getLogFile($Cache, $File);
    }
    
    
    
    
    
    
    
    public static function getFileMatch
    (
        $File="[a-zA-Z0-9x_]+",
        $Extension="[a-z]+"
    )
    {
        return SystemTheme_Paths::getFileMatch($File, $Extension);
    }
    
    public static function getPartMatch
    (
        $Part="[a-z]+", 
        $Dir="[a-z0-9]+", 
        $File="[a-zA-Z0-9x_]+",
        $Extension="[a-z]+"
    )
    {
        return SystemTheme_Paths::getPartMatch($Part, $Dir, $File, $Extension);
    }
    
    public static function getCacheMatch
    (
        $Type="[a-z]+", 
        $File="[a-zA-Z0-9x_]+",
        $Extension="[a-z]+"
    )
    {
        return SystemTheme_Paths::getFileMatch($Type, $File, $Extension);
    }
    
    public static function getLogMatch
    (
        $Type="[a-z]+", 
        $File="[a-zA-Z0-9x_]+",
        $Extension="[a-z]+"
    )
    {
        return SystemTheme_Paths::getFileMatch($Type, $File, $Extension);
    }
    
    
    
    public static function getMatch($Type, $Params)
    {
        $Params = self::completeMatchArgs($Params);
        switch ( strtolower($Type) )
        {
            case "file":
                return self::getFileMatch
                    (
                        $Params["file"], 
                        $Params["extension"]
                    );
            case "part":
                return self::getPartMatch
                    (
                        $Params["part"], 
                        $Params["dir"], 
                        $Params["file"],
                        $Params["extension"]
                    );
            case "cache":
                return self::getCacheMatch
                    (
                        $Params["type"], 
                        $Params["file"],
                        $Params["extension"]
                    );
            case "log":
                return self::getLogMatch
                    (
                        $Params["type"], 
                        $Params["file"],
                        $Params["extension"]
                    );
        };
        return false;
    }
    
    

}