<?php

    
class Core_List extends Core_Table
    implements Core_DriverReceiverBindings 
{

    private $Vars = array();
   
    public function __construct
    (
        $First="__special__value__", $Second="__special__value__"
    )
    {
        //check the params
        switch ( gettype($First) )
        {
            case "array":
                $this->Vars = array_values($First);
                break;
            case "object":
                if ( method_exists($First, "getDeepList") )
                { 
                    $this->Vars = $First->getDeepList();
                };
                break;
        };
        //check if $this->Vars is really an array
        if ( !is_array($this->Vars) )
        {
            $this->Vars = array();
        };
    }
    
    public function getText()
    {
        return implode(" ", $this->Vars);
    }
    
    public function getList()
    {
        return $this->Vars;
    }
    
    public function getTable()
    {
        return $this->getList();
    }
    
    public function getDeepList()
    {
        return $this->getList();    
    }
    
    public function getDeepTable()
    {
        return $this->getList();
    }
   
    
    public function add($Value)
    {
        $this->push($Value);
    }
    
    public function push($Value)
    {
        array_push($this->Vars, $Value);
    }
    
    public function pop($Value)
    {
        array_pop($this->Vars, $Value);
    }
    
    public function shift($Value)
    {
        array_shift($this->Vars, $Value);
    }
    
    public function unshift($Value)
    {
        array_unshift($this->Vars, $Value);
    }
   
    public function getAll()
    {
        return $this->Vars;
    }
    
}  

 ?>