<?php

    
class Core_Table
    implements Core_DriverReceiverBindings 
{

    private $Vars = array();
   
    public function __construct
    (
        $First="__special__value__", $Second="__special__value__"
    )
    {
        //check the params
        switch ( gettype($First) )
        {
            case "array":
                $this->Vars = $First;
                break;
            case "object":
                if ( method_exists($First, "getDeepTable") )
                { 
                    $this->Vars = $First->getDeepTable();
                };
                break;
        };
        //check if $this->Vars is really an array
        if ( !is_array($this->Vars) )
        {
            $this->Vars = array();
        };
    }
    
    public function getText()
    {
        return implode(" ", $this->Vars);
    }
    
    public function getList()
    {
        return array_values($this->getTable());
    }
    
    public function getTable()
    {
        $ReturnArray = array();
        foreach ( $this->Vars as $Name => $Value )
        {
            if ( gettype($Value) != "array" )
            {
                $ReturnArray[$Name] = $Value;
            };
        };
        return $ReturnArray;
    }
    
    public function getDeepList()
    {
        return array_values($this->getDeepArray());
    }
    
    public function getDeepTable()
    {
        return $this->Vars;
    }
   
    
    public function add($Name, $Value)
    {
        if( !isset($this->Vars[$Name]) )
        {
            $this->Vars[$Name] = $Value;
            return true;
        };
        return false;        
    }
   
    
    public function set($Name, $Value)
    {
        if( isset($this->Vars[$Name]) )
        {
            $this->Vars[$Name] = $Value;
            return true;
        };
        return false;
    }
    

    public function get($Name, $Value="__special__value__")
    {
        if( $Value === "__special__value__")
        {
            //get the value
            if( isset($this->Vars[$Name]) )
            {
                return $this->Vars[$Name];
            };
            return false;
        }
        else
        {
            //compare the values
            if( isset($this->Vars[$Name]) )
            {
                if( $this->Vars[$Name] == $Value )
                {
                    return true;
                }
                else
                {
                    return false;
                };
            };
            return false;
        };
    }
    

    public function handle($Name, $Value="__special__value__")
    {
        //check if both parameters exist
        if( $Value === "__special__value__" )
        {
            return $this->get($Name);
        };
        //check if the variable already exists
        if( isset($this->Vars[$Name]) ) 
        {
            return $this->set($Name, $Value);
        }
        else
        {
            return $this->add($Name, $Value);
        };
    
    }
    
    public function save($Name, $Value)
    {
        return $this->handle($Name, $Value);
    }
    
    public function is($Name)
    {
        if( isset($this->Vars[$Name]) )
        {
            return true;
        };
        return false;
    }
   
    public function getAll()
    {
        return $this->Vars;
    }
    
}  

 ?>