<?php

class Core_Services_EventMan extends Core_RuntimeService
{

    protected $RegisteredObjects = array();
    protected $ThrownEvents = array();

    public function __construct()
    {
    }
    
    public function registerObject($Object)
    {
        //register the object
        $this->RegisteredObjects[] = $Object;
        //throw all events to this object
        $this->sendAllEvents($Object, 0);
    }
    
    public function throwEvent($Event)
    {
        //validate the event name
        $Event = Core_LibMasking::maskFunctionName($Event);
        //register the event
        $ThrownEvents[] = $Event;
        //throw the event
        $this->sendEventToAll($Event, 1);
    }

  
    protected function sendEvent($Event, $Object, $Type=1)
    { //Types: 0 = bygone, 1 = actual
        //check the parameters
        if ( !is_object($Object) )
        {
            return false;
        };
        //check if a specific method exists
        $MethodName = "handle".$Event;
        if ( method_exists($Object, $MethodName) )
        {
            $Object->$MethodName($Type);
        };
        //check if an catchAll-method exists
        if ( method_exists($Object, "catchAll") )
        {
            $Object->catchAll($Type, $Event);
        };

        
    }
    
    protected function sendEventToAll($Event, $Type=1)
    {
        foreach ( $this->RegisteredObjects as $Number => $Object )
        {
            $this->sendEvent($Event, $Object, $Type);
        };
    }
    
    protected function sendAllEvents($Object, $Type=1)
    {
        foreach ( $this->ThrownEvents as $Number => $Event )
        {
            $this->sendEvent($Event, $Object, $Type);
        };
    } 

}


 ?>