<?php
/* EatingEngine E2 - A flexible, modular web framework
    Copyright (C)   2005   Thomas Gabor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


//TODO: build to allow not all screens (using initscripts)

class Core_Services_View extends Core_StaticService
{

    protected $Screens = array();
    //$Screens["Monitor"] = <instance of a subclass of Core_Screen>;
    
    public function construct()
    { 
        //load the parameters
        $Params = Kernel()->Core_Model()->get("Core", "Params", "Core_Table");
        //load a screen for every parameter if possible
        if ( !is_array($Params->get("screen")) )
        {
            return;
        };
        foreach ( $Params->get("screen") as $Name => $Information )
        { 
            //load the screen name
            $PartName = preg_replace("/(.+)_(.+)/", "\\1", $Name);
            $ScreenName = preg_replace("/(.+)_(.+)/", "\\2", $Name);
            //check if there is such a screen
            $ClassName = Core_LibsysClasses::getName
                ($PartName, "Screens", $ScreenName);
            if 
            ( 
                class_exists($ClassName) 
                && Core_LibClass::extendsClass($ClassName, "Core_Screen")
            )
             {
                //get the part and module
                /* OLD STUFF
                $Part = Kernel()->Core_Load()
                    ->getRequestedPartName($Information["value"]);
                $Module = Kernel()->Core_Load()
                    ->getRequestedModuleName($Information["value"]);
                */
                $Module = Kernel()->Core_Load()
                    ->getRequestedModule($Information["value"]);
                $Part = $Module->getPart();
                //save the screen
                $this->Screens[] = new $ClassName
                    (
                        $Part,
                        $Module,
                        $Information["params"]
                    );
            };
        };
    }
    
    public function output()
    {
        //go through all screens and request an output
        foreach ( $this->Screens as $Name => $Screen )
        { 
            $Screen->output();
        };
    }

}



 ?>