<?php

abstract class SystemTheme_Names
{

    static private $SimplePattern = "([a-zA-Z0-9x_]+)";
    static private $BasePattern = "((?:[a-zA-Z]+)(?:[a-zA-Zx_]+))";

    static final function getClassPattern()
    {
        return self::$BasePattern;
    }
    
    static final function getNamespacePattern()
    {
        return "([a-zA-Z]+)";
    }
       
    static final function getVarPattern()
    {
        return self::$BasePattern;
    }
    
    static final function getFuncPattern()
    {
        return "[a-zA-Zx_]+" ;
    }
    
    static final function getFilePattern()
    {
        return self::$SimplePattern . "\.([a-z]+)\.php";
    }
    
    static final function getDirPattern()
    {
        return self::$SimplePattern . "\/";
    }

    static final function getPathPattern()
    {
        return 
            "(\.\/)*"
            . "(\.\.\/)*" 
            . "(" . self::getDirPattern() . ")+" 
            . "(" . self::getFilePattern() . ")?";
    }
    
}

 ?>