<?php

abstract class SystemTheme_Paths
{

    static private $Root = "../../../";

    static final function getRoot()
    {
        return self::$Root;
    }
    
    static final function getMain()
    {
        return self::$Root . "parts/core/lib/Core_Main.class.php";
    }
    
    
    
    
    static final function getPartsDir()
    {
        return self::getRoot() . "parts/";
    }
    
    static final function getPart($Part)
    {
        return self::getPartsDir() . strtolower($Part) . "/";
    }
    
    static final function getSubdir($Part, $Dir)
    {
        return self::getPart($Part) . strtolower($Dir) . "/";
    }
    
    static final function getSub($Part, $Dir)
    {
        return self::getSubdir($Part, $Dir);
    }
    
    static final function getPartsFile($Part, $Dir, $File)
    {
        return self::getSubdir($Part, $Dir) . $File . ".php";
    }
    
    static final function getFile($Part, $Dir, $File)
    {
        return self::getPartsFile($Part, $Dir, $File);
    }
    
    
    static final function getLibFile($Part, $File)
    {
        return self::getFile($Part, "lib", $File);
    }
    
    
    
    
    
    static final function getCacheDir()
    {
        return self::getRoot() . "cache/";
    }
    
    static final function getCache($Type)
    {
        return self::getCacheDir . strtolower($Type) . "/";
    }
    
    static final function getCacheFile($Type, $File)
    {
        return self::getCache($Type) . $File . ".php";
    }
    
    
    
    
    
    static final function getLogDir()
    {
        return self::getRoot() . "log/";
    }
    
    static final function getLogs($Type)
    {
        return self::getLogDir . strtolower($Type) . "/";
    }
    
    static final function getLogFile($Type, $File)
    {
        return self::getLogs($Type) . $File . ".php";
    }
    
    static final function getLog($Type, $File)
    {
        return self::getLogFile($Type, $File);
    }
    
    
    
    
    
    
    static final function getFileMatch
    (
        $Name="[a-zA-Z0-9x_]+",
        $Extension="[a-z]+"
    )
    {
        return "(" . $Name . ")\.(" . $Extension . ")\.php";
    }
    
    static final function getPartMatch
    (
        $Part="[a-z]+", 
        $Dir="[a-z0-9]+", 
        $File="[a-zA-Z0-9x_]+",
        $Extension="[a-z]+"
    )
    {
        return self::getParts() 
            . "(". $Part . ")/" 
            . "(?:(" . $Dir . ")/)+" 
            . "(" . $File . ")\." 
            . "(" . $Extension . ")\.php";
    }
    
    static final function getCacheMatch
    (
        $Type="[a-z]+", 
        $File="[a-zA-Z0-9x_]+",
        $Extension="[a-z]+"
    )
    {
        return self::getCacheDir() 
            . "(" . $Type . ")/"
            . "(" . $File . ")\."
            . "(" . $Extension . ")\.php";
    }
    
    static final function getLogMatch
    (
        $Type="[a-z]+", 
        $File="[a-zA-Z0-9x_]+",
        $Extension="[a-z]+"
    )
    {
        return self::getLogDir() 
            . "(" . $Type . ")/"
            . "(" . $File . ")\."
            . "(" . $Extension . ")\.php";
    }
    

}


 ?>