<?php

class Esse_Services_Sources extends Core_RuntimeService
{

    protected $Config = null;

    public function __construct()
    {
        //load the configuration
        $this->Config = new Core_Null();
        $this->Config = Kernel()->Core_Model()->get
            ("Esse", array("Config", "Sources"), "Core_Table");
    }
    
    public function getInformation($Name, $InfoName)
    {
        //check if the source exists 
        if ( $this->Config->is($Name) != true )
        { 
            return null;
        };
        //load the configuration for this one source
        $SourceConfig = new Core_Table($this->Config->get($Name));
        //get the requested information
        $Information = $SourceConfig->get($InfoName);
        return $Information;
    }
    
    public function getClass($Name)
    {
        return $this->getInformation($Name, "class");
    }
    
    public function getDriverClass($Name)
    {
        return $this->getInformation($Name, "driver");
    }
    
    public function get($Name)
    {
        //get the class name and check it
        $Class = $this->getClass($Name);
        if ( Core_LibClass::extendsClass($Class, "Esse_Source") !== true )
        {
            return new Core_Null();
        };
        //add a hit
        $this->addHit($Name);
        return new $Class($Name);
    }
    
    public function getHits($Name)
    {
        $Hits = Kernel()->Core_Model()->get
            ("Esse", array("Data", "Hits"), "Core_Table");
        return $Hits->get($Name);
    }
    
    public function addHit($Name)
    {
        //load the hits
        $Hits = Kernel()->Core_Model()->get
            ("Esse", array("Data", "Hits"), "Core_Table");
        //add one
        $Hits->save($Name, $Hits->get($Name) + 1);
        //save new value
        Kernel()->Core_Model()->set("Esse", array("Data", "Hits"), $Hits);
        //return something (new value)
        return $Hits->get($Name) + 1;
    }
    
}

 ?>