<?php

class Esse_Templates_CompoundedContent extends Core_Templates_MixedPhp
{
    protected $Type = "html";
    
    protected $Source = null;

    protected function construct()
    {
        //save the source if specified
        $this->Source = new Core_Null();
        if ( isset($this->Params["CorrespondingSource"]) )
        {
            //check if the source is correct
            $Source = $this->Params["CorrespondingSource"];
            if ( Core_LibClass::extendsClass($Source, "Esse_Source") === true )
            {
                $this->Source = $Source;
            };
        };
        //call the parent constructor for PHP executing
        parent::construct();
        $this->succeed();
    }
    
    protected function getSource()
    {
        return $this->Source->get();
    }
    
    protected function getExternalSource($Name)
    { 
        //load the source
        $Source = Kernel()->Esse_Sources()->get($Name);
        //load the template
        $Template = new Esse_Templates_CompoundedContent
            (
                $this->Style,
                $this->FilePart,
                $this->FileStyle,
                "src_" . $Name,
                array
                    (
                        "CorrespondingSource" => $Source
                    )
            );
        //start output buffering
        ob_start();
        //save the output of the template
        $Template->echoOutput();
        $Content = ob_get_contents();
        //delete the buffered output
        ob_end_clean();
        //return the output
        return $Content;
    }
}