<?php

class Extras_Drivers_Package extends Core_Driver
    implements Core_DriverBindings
{

    protected $Content = null;
    protected $Driver = null;

    protected function construct()
    {
        //set default values
        $this->Content = new Core_Empty();
        $this->Driver = new Core_Null();
        
        //save the sub-directories and the name
        $Spaces = $this->getEntireSource();
        //save which type of information of the packe is demanded
        $Information = array_pop($Spaces);
        //save the information
        switch ( $Information )
        {
            case "drivers":
                //load configuration driver
                $this->Driver = $this->getDriver
                    (
                        "Core", 
                        "ArrayConfig", 
                        $this->getPart(),
                        $Spaces
                    );
                break;
            case "pkg":
            default: 
                //load class driver
                $this->Driver = $this->getDriver
                    (
                        "Extras", 
                        "Class", 
                        $this->getPart(),
                        $Spaces
                    );
        };
        //save the content
        $this->Content = $this->Driver->getObject();
        //check if the driver had success
        if ( $this->Driver->data_Success_get() === true )
        {
            $this->succeed();
        };
    }
    
    public function getObject()
    {
        return $this->Content;
    }
    
    public function getText()
    { 
        return $this->Content->getText();
    }
    
    public function getList()
    {
        return $this->Content->getList();
    }
    
    public function getTable()
    {
        return $this->Content->getTable();
    }
    
    public function getDeepList()
    {
        return $this->Content->getDeepList();
    }
    
    public function getDeepTable()
    {
        return $this->Content->getDeepTable();
    }
    
    public function set($Reiceiver)
    {
        //not possible
    }

}

 ?>