<?php

class Extras_Drivers_PkgDriver extends Core_Drivers_Driver
    implements Core_DriverBindings
{

    /*  this class is used to access sources which are contained by a package.
        In order to do this, this driver uses the drivers.conf.php which
        should also come with the package.
        
        remember: this class extends the driver for drivers from Core and
        therefore doesn't need to define all functions itself
     */ 
    
    protected function construct()
    {
        //save the default values
        $this->Driver = new Core_Null();
    
        //save the requested class as driver receiver
        $this->RequestedClass = $this->getFirstParam
                (array("Class", "RequestedClass", "ClassName"));
                
        //load the configuration file of the _package_
        $Config = new Core_Table($this->getDriver
            (
                "Core", 
                "ArrayConfig", 
                $this->getPart(), 
                array($this->getSource(0), $this->getSource(1), "Drivers")
            ));
        //search for an appropiate driver
        $Driver = $this->loadDriver
            (
                $this->getDriverByConfig($Config->getDeepTable())
            );
        //check if the operation was successful
        if ( is_object($Driver) )
        {
            $this->Driver = $Driver;
            $this->succeed();
            return;
        };   
        
    }
    
    public function getText()
    {
        if ( is_string($this->Driver->getText()) )
        {
            return $this->Driver->getText();
        };
        return "";
    }
    
    public function getList()
    {
        if ( is_array($this->Driver->getList()) )
        {
            return $this->Driver->getList();
        };
        return array();
    }
    
    public function getTable()
    {
        if ( is_array($this->Driver->getTable()) )
        {
            return $this->Driver->getTable();
        };
        return array();
    }
    
    public function getDeepList()
    {
        if ( is_array($this->Driver->getDeepList()) )
        {
            return $this->Driver->getDeepList();
        };
        return array();
    }
    
    public function getDeepTable()
    {
        if ( is_array($this->Driver->getDeepTable()) )
        {
            return $this->Driver->getDeepTable();
        };
        return array();
    }
}

 ?>