<?php

abstract class Extras_AdvancedModule extends Core_Module
{    

    private $Mode = "default";

    protected $Report = array();
 
    public function get($Name)
    {
        if ( in_array($Name, $this->Report) )
        {
            return $this->$Name;
        };
        return null;
    }
    
    public function getMode()
    {
        return $this->Mode;
    }
    
    
    protected function runMode($Mode)
    {
        $Method = "runMode_" . $Mode;
        if ( method_exists($this, $Method) == true )
        {
            $this->Mode = $Mode;
            $this->$Method();
            return true;
        };
        return false;
    }

    protected function runModule()
    {
        $Mode = "default";
        foreach ( array("modus", "mode", "Modus", "Mode") as $Param )
        {
            switch( gettype($this->getParam($Param)) )
            {
                case "integer":
                    $Mode = $this->getParam($Param);
                    break;
                case "string":
                    $Mode = preg_replace
                        ("/\W/", "", $this->getParam($Param));
                    break;
                default:
                    continue;
            };
        };
        if ( method_exists($this, "prepareModes") )
        {
            $this->prepareModes();
        };
        if ( $this->runMode($Mode) != true)
        {
            $this->runMode("default");
        };
        if ( method_exists($this, "completeModes") )
        {
            $this->completeModes();
        };
    }
    
    protected function report($Name)
    {
        $this->Report[] = $Name;
    }

}

 ?>