<?php

class Extras_Modules_Install extends Extras_AdvancedModule
{

    protected $Config = array();
    
    protected $InstallationAllowed = false;
    protected $PWCorrect = false;
    protected $PackageExists = false;
   
    public function construct()
    {
        //load the package service
        Kernel()->Extras_Packages();
        //load the configuration
        $this->Config = Kernel()->Core_Model()
            ->get("Extras", array("Config", "Packages"), "Core_Table");
        //load the password
        $this->Password = Kernel()->Core_Model()
            ->get("Extras", array("Data", "InstallPW"), "Core_Text"); 
    }
    
    protected function prepareModes()
    {
        if ( $this->Config->get("AllowInstallation") == true )
        {
            $this->InstallationAllowed = true;
        };
        $this->report("InstallationAllowed");
        
        $InstallPW = Kernel()->Core_Model()->get
            ("Extras", array("Data", "InstallPW"), "Extras_EncryptedText");
        if ( $InstallPW->is($this->getParam("password")) === true )
        {
            $this->PWCorrect = true;
        };
        $this->report("PWCorrect");
        
        if ( Kernel()->Extras_Packages()->check($this->getParam("package")) )
        {
            $this->PackageExists = true;
        };
        $this->report("PackageExists");
    }
    
    public function runMode_default()
    {
        $this->succeed();
    }
    
    public function runMode_choose()
    {
        $this->succeed();
    }
    
    public function runMode_install()
    {
        if 
        (
            ($this->InstallationAllowed === true )
            && ($this->PWCorrect === true )
            && ($this->PackageExists === true )
        )
        {
            Kernel()->Extras_Packages()->install($this->getParam("package"));
            $this->succeed();
        };
    }

}

 ?>